require 'rails/generators'
module VueCrud
    class InstallGenerator < Rails::Generators::Base
        source_root File.expand_path("../templates/assets", __FILE__)

        def copy_all
            # codemirror
            copy_file "javascripts/codemirror.js", "app/assets/javascripts/codemirror.js"
            copy_file "stylesheets/codemirror.css", "app/assets/stylesheets/codemirror.css"
            # fa
            directory 'stylesheets/fa', 'app/assets/stylesheets/fa'
            directory 'fonts/fa', 'app/assets/fonts/fa'
            # froala
            directory 'javascripts/froala_editor', 'app/assets/javascripts/froala_editor'
            directory 'stylesheets/froala_editor', 'app/assets/stylesheets/froala_editor'
            directory 'images/froala_editor', 'app/assets/images/froala_editor'
            # pace
            copy_file "javascripts/pace.min.js", "app/assets/javascripts/pace.min.js"
            copy_file "stylesheets/pace.min.css", "app/assets/stylesheets/pace.min.css"
            # semantic-ui
            directory 'javascripts/semantic-ui', 'app/assets/javascripts/semantic-ui'
            directory 'stylesheets/semantic-ui', 'app/assets/stylesheets/semantic-ui'
            directory 'images/semantic-ui', 'app/assets/images/semantic-ui'
            # sortable
            copy_file "javascripts/sortable.js", "app/assets/javascripts/sortable.js"
            # template
            copy_file "vue_crud.html", "public/vue_crud.html"
            # vuejs
            copy_file "javascripts/vue.js", "app/assets/javascripts/vue.js"
        end
    end
end
