class User < ApplicationRecord
  has_one :profile, :dependent => :destroy
  has_many :services, :dependent => :destroy
  accepts_nested_attributes_for :profile, update_only: true
  devise :database_authenticatable, :registerable, :recoverable, :rememberable, :trackable, :validatable

  def first_service
      self.services.first if self.services.first.present?
  end
end
