if($.FE !== undefined) {
    $.FE.prototype.reset = function () {
        this.$el.html('');
    }
    $.FE.prototype.refresh = function () {
        this.$el.html(this.$oel.val());
    }
}
$(document).ajaxStart(function() { Pace.restart(); });
Vue.config.devtools = true;
Pace.on('done', function() {
    $('#form-progress').val('0');
});
var event_hub = new Vue();
var modal_mixin = {};
var model_mixin = {};
var root_mixin = {};
function sleep(time) {
    return new Promise((resolve) => setTimeout(resolve, time));
}
function obj_to_json(obj) {
    return JSON.parse(JSON.stringify(obj));
}
// Array.prototype.find_and_replace = function(id, new_obj){
//     for(var n = 0; n < this.length; n++) {
//         var current_id = this[n].id || this[n].ID;
//         if(current_id == id){
//             console.log(this[n]);
//             this[n] = new_obj;
//             return true;
//         }
//     }
//     return false;
// };
function urlParser(url, obj, suffix) {
    var parser = document.createElement('a');
    parser.href = url;
    parser.parameters = parser.pathname.split('/').filter(function (str) {
        return str.match(':');
    });
    var url = parser.protocol + "//" + parser.host;
    $.each(parser.parameters, function(i, key){
        parser.pathname = parser.pathname.replace(key, obj[key.replace(":", "")]);
    });
    url += parser.pathname + suffix + location.search;
    return url;
}
function removeParam(key, sourceURL) {
    var rtn = sourceURL.split("?")[0],
        param,
        params_arr = [],
        queryString = (sourceURL.indexOf("?") !== -1) ? sourceURL.split("?")[1] : "";
    if (queryString !== "") {
        params_arr = queryString.split("&");
        for (var i = params_arr.length - 1; i >= 0; i -= 1) {
            param = params_arr[i].split("=")[0];
            if (param === key) {
                params_arr.splice(i, 1);
            }
        }
        rtn = rtn + "?" + params_arr.join("&");
    }
    return rtn;
}
function updateQueryStringParam(key, value) {
    baseUrl = [location.protocol, '//', location.host, location.pathname].join('');
    urlQueryString = document.location.search;
    var newParam = key + '=' + value,
    params = '?' + newParam;

    // If the "search" string exists, then build params from it
    if (urlQueryString) {
        keyRegex = new RegExp('([\?&])' + key + '[^&]*');
        // If param exists already, update it
        if (urlQueryString.match(keyRegex) !== null) {
            params = urlQueryString.replace(keyRegex, "$1" + newParam);
        } else { // Otherwise, add it to end of query string
            params = urlQueryString + '&' + newParam;
        }
    }
    window.history.replaceState({}, "", baseUrl + params);
}
function getParameterByName(name) {
    var url = window.location.href;
    name = name.replace(/[\[\]]/g, "\\$&");
    var regex = new RegExp("[?&]" + name + "(=([^&#]*)|&|#|$)"),
        results = regex.exec(url);
    if (!results) return '';
    if (!results[2]) return '';
    return decodeURIComponent(results[2].replace(/\+/g, " "));
}
function vueCRUD_init(params) {
    if(params === undefined) {
       addClose = {};
    }
    Vue.filter('datetime', function (value) {
        return new Date(value).toLocaleString();
    })
    Vue.filter('boolean', function (value) {
        return value? '✔ 是':'✘ 否';
    })
    var default_options = {
        column_type: 'card',
        countOfPage: 9,
        sortable: false,
        info_url: window.location.pathname + '/info.json'
    }
    var options = $.extend(true, {}, default_options, params)
    Vue.directive('froala', {
        inserted: function (el) {
            $(el).froalaEditor({
                charCounterCount: false,
                placeholderText: "",
                language: 'zh_tw'
            }).on('froalaEditor.contentChanged', function (e, editor) {
                event_hub.$emit('changeValue', el);
            }).addClass('needRefresh');
        }
    })
    Vue.directive('sortable', {
        inserted: function (el) {
            if(options.sortable) {
                filter: '.is_deleted';
                var sortable = new Sortable(el, {
                    onUpdate: function (evt) {
                        event_hub.$emit('updateSort');
                    }
                });
            }
        }
    })
    Vue.directive('toggle', {
        inserted: function (el) {
            $(el).css('cursor', 'pointer').click(function(){
                $(this).next().toggle();
            });
        }
    })
    var modalComponent = Vue.component('modal', {
        mixins: [modal_mixin],
        template: '#modal',
        data: function() {
            return {
                model_attributes: [],
                errors: {},
                model: {},
                action_name: '',
                defaultMode: true
            }
        },
        mounted: function() {
            // Sync errors and model from modelComponent
            event_hub.$on('update_error', function(errors) {
                this.errors = errors;
            }.bind(this));
            event_hub.$on('update_model_attributes', function(model_attributes) {
                this.model_attributes = model_attributes;
            }.bind(this));
            event_hub.$on('update_model', function(model) {
                this.model = model;
            }.bind(this));
            // Modes and Actions
            event_hub.$on('change_mode', function(mode, boolean) {
                this[mode] = boolean;
            }.bind(this));
            event_hub.$on('update_action_name', function(action_name) {
                this.action_name = action_name;
            }.bind(this));
            // Modal actions
            event_hub.$on('openModal', function() {
                this.openModal();
            }.bind(this));
            event_hub.$on('closeModal', function() {
                this.closeModal();
            }.bind(this));
            event_hub.$on('dimmerOn', function() {
                this.dimmerOn();
            }.bind(this));
            event_hub.$on('dimmerOff', function() {
                this.dimmerOff();
            }.bind(this));
            // For froalaEditor
            event_hub.$on('changeValue', function(el) {
                this.model[$(el).attr('attribute')] = $(el).val();
            }.bind(this));
        },
        methods: {
            modalSubmit: function() {
                event_hub.$emit('modalSubmit');
            },
            dimmerOn: function() {
                $(this.$el).find('.dimmer').addClass('active');
            },
            dimmerOff: function() {
                $(this.$el).find('.dimmer').removeClass('active');
            },
            openModal: function() {
                event_hub.$off('modalSubmit');
                var that = this;
                $(this.$el).modal({
                    observeChanges: true,
                    transition: 'fade down',
                    onShow: function() {
                        that.errors = {};
                        $('.needRefresh').froalaEditor('reset');
                        $(this).find('select.ui.dropdown').dropdown();
                        $(this).find('.ui.checkbox').checkbox();
                        if(typeof modalOpen !== "undefined") modalOpen(this);
                    },
                    onVisible: function() {
                        $('.needRefresh').froalaEditor('refresh');
                    },
                    onHide: function() {
                        event_hub.$emit('modalClose');
                        that.dimmerOff();
                        if(typeof modalClose !== "undefined") modalClose(this);
                    }
                }).modal('show');
            },
            closeModal: function() {
                sleep(500).then(() => {
                    $(this.$el).modal('hide');
                });
            }
        }
    })

    var modelComponent = Vue.component('model', {
        mixins: [model_mixin],
        template: '#model-' + options.column_type,
        props: {
            original_model: Object,
            selected_attribute: String,
            info: Object
        },
        data: function() {
            return {
                // model: {},
                progress: '0',
                errors: {},
                modified: false,
                deleteMode: false,
                is_success: false,
                is_deleted: false,
                is_restore_failed: false
            }
        },
        watch: {
            model: {
                handler: function (value, old_value) {
                    // old_value and value(model self) will be changed on Computed method
                    // Only watch model's data change so set value === old_value
                    // value === old_value means model not change
                    if(value === old_value) {
                        this.modified = true;
                        this.is_success = false;
                    }
                },
                deep: true
            }
        },
        mounted: function() {
            this.model = this.original_model;

            event_hub.$on('update_progress', function(progress) {
                this.progress = progress;
            }.bind(this));
            event_hub.$on('updateSort', function(progress) {
                if($(this.$el).is(":visible")) {
                    var sort = ($(this.$el).index() + 1);
                    if(getParameterByName("p") > 1) {
                        sort = sort + ((getParameterByName("p") - 1) * options.countOfPage);
                    }
                    this.model.sort = sort;
                    this.updateModel();
                }
            }.bind(this));
        },
        computed: {
            model: function() {
                return this.original_model
            }
        },
        methods: {
            toggleTrue: function(name) {
                var that = this;
                var toggle_data = {};
                toggle_data[name] = true;
                $.ajax({
                    method: that.info.actions.update.method,
                    data: toggle_data,
                    url: urlParser(that.info.actions.update.url, that.model, that.info.actions.update.suffix),
                    success: function(res) {
                        that.model[name] = true;
                        sleep(1500).then(() => {
                            that.modified = false;
                        });
                    }
                });
            },
            toggleFalse: function(name) {
                var that = this;
                var toggle_data = {};
                toggle_data[name] = false;
                $.ajax({
                    method: that.info.actions.update.method,
                    data: toggle_data,
                    url: urlParser(that.info.actions.update.url, that.model, that.info.actions.update.suffix),
                    success: function(res) {
                        that.model[name] = false;
                        sleep(1500).then(() => {
                            that.modified = false;
                        });
                    }
                });
            },
            editModel: function(action_name) {
                var url = this.info.actions.delete.url;
                event_hub.$emit('openModal');
                event_hub.$emit('update_model_attributes', this.info.model_attributes);
                event_hub.$emit('update_model', this.model);
                event_hub.$emit('update_action_name', action_name + this.info.titles.display_name);

                // Bind modalSubmit when modalComponent submit
                // It will be off when modal close
                event_hub.$on('modalSubmit', function() {
                    this.updateModel();
                }.bind(this));
            },
            restoreModel: function() {
                var that = this;
                $.ajax({
                    method: that.info.actions.create.method,
                    data: obj_to_json(that.model),
                    url: urlParser(that.info.actions.create.url, that.model, that.info.actions.create.suffix),
                    success: function(res) {
                        that.model = res;
                        that.deleteMode = false;
                        that.is_deleted = false;
                        that.is_success = true;
                        sleep(1500).then(() => {
                            that.is_success = false;
                        });
                    },
                    error: function(res) {
                        that.is_deleted = false;
                        that.is_restore_failed = true;
                        alert('復原失敗，請記錄資料並重新建立');
                    }
                });
            },
            deleteModel: function () {
                var that = this;
                if(confirm("Are you sure?") == true) {
                    that.deleteMode = true;
                    $.ajax({
                        method: that.info.actions.delete.method,
                        url: urlParser(that.info.actions.delete.url, that.model, that.info.actions.delete.suffix),
                        success: function(res) {
                            that.is_deleted = true;
                        },
                        error: function(res) {
                            that.deleteMode = false;
                        }
                    })
                }
                else {
                    that.deleteMode = false;
                }
            },
            updateModel: function() {
                var that = this;
                $.ajax({
                    method: that.info.actions.update.method,
                    data: obj_to_json(that.model),
                    url: urlParser(that.info.actions.update.url, that.model, that.info.actions.update.suffix),
                    beforeSend: function() {
                        event_hub.$emit('dimmerOn');
                        $('.progress-bar').css('width', '0');
                    },
                    success: function(res) {
                        that.errors = {};
                        that.modified = false;
                        that.is_success = true;
                        event_hub.$emit('closeModal');
                        event_hub.$emit('dimmerOff');
                        sleep(1500).then(() => {
                            that.is_success = false;
                        });
                    },
                    error: function(res) {
                        event_hub.$emit('update_error', res.responseJSON);
                        event_hub.$emit('dimmerOff');
                    }
                });
            }
        }
    })

    var rootVue = new Vue({
        mixins: [root_mixin],
        el: '#vue_crud',
        data: function() {
            return {
                default_url: '',
                column_type: options.column_type || 'card',
                models: [],
                model: {},
                info: {
                    actions: {
                        index: {},
                        create: {},
                        read: {},
                        update: {},
                        delete: {}
                    },
                    url_prefix: '',
                    titles: {},
                    model_attributes: []
                },
                errors: {},
                progress: '0',
                countOfPage: options.countOfPage || 9,
                currentPage: getParameterByName("p") || 1,
                searchQuery: getParameterByName("q"),
                filteredModelCount: null,
                is_calculating: false,
                selected_attribute: getParameterByName("sa"),
                selected_text: getParameterByName("st"),
                is_loaded: false
            }
        },
        mounted: function() {
            var that = this;
            that.load_instance(options.info_url);

            event_hub.$on('restoreCreate', function(model) {
                this.model = model;
                this.restoreModel();
            }.bind(this));

            // delegate filter dropdown click event
            $(document).delegate('.attribute_option', 'click', function(event) {
                var selected_attribute = $('.attribute_select').find('.item.selected').attr('target') || "Attribute";
                var selected_text = $('.attribute_select').find('.item.selected').attr('target_text') || "欄位";
                that.selected_attribute = selected_attribute;
                that.selected_text = selected_text;
                updateQueryStringParam('sa', that.selected_attribute);
                updateQueryStringParam('st', that.selected_text);
            });

            // binding PACE progress with Vue
            event_hub.$on('update_progress', function(progress) {
                this.progress = progress;
            }.bind(this));

            $('#form-progress').change(function(){
                event_hub.$emit('update_progress', $(this).val());
            });
        },
        methods: {
            load_instance: function(info_url) {
                var that = this;
                $.ajax({
                    url: info_url,
                    success: function(res) {
                        that.info = res;
                        that.model = {};
                        $.each(res.model_attributes, function(i, attribute){
                            that.model[attribute.name] = attribute.default_value;
                        })
                        var default_url = that.info.actions.index.url + that.info.actions.index.suffix + location.search;
                        default_url = removeParam("p", default_url);
                        default_url = removeParam("q", default_url);
                        default_url = removeParam("mp", default_url);
                        default_url = removeParam("sa", default_url);
                        default_url = removeParam("st", default_url);
                        that.default_url = default_url;
                        $.ajax({
                            url: urlParser(that.info.actions.index.url, that.model, that.info.actions.index.suffix),
                            success: function(res) {
                                that.models = res;
                                that.is_loaded = true;
                            }
                        });
                    }
                });
            },
            addModel: function(action_name) {
                event_hub.$emit('openModal');
                event_hub.$emit('update_model_attributes', this.info.model_attributes);
                event_hub.$emit('update_model', this.model);
                event_hub.$emit('update_action_name', action_name + this.info.titles.display_name);
                event_hub.$on('modalSubmit', function() {
                    this.createModel();
                }.bind(this));
            },
            setPage: function(idx){
                if( idx <= 0 || idx > this.totalPage ){
                    return;
                }
                this.currentPage = idx;

                updateQueryStringParam('p', this.currentPage);
            },
            createModel: function () {
                var that = this;
                $.ajax({
                    method: that.info.actions.create.method,
                    data: obj_to_json(that.model),
                    url: urlParser(that.info.actions.create.url, that.model, that.info.actions.create.suffix),
                    beforeSend: function() {
                        event_hub.$emit('dimmerOn');
                        $('.progress-bar').css('width', '0');
                    },
                    success: function(res) {
                        event_hub.$emit('closeModal');
                        event_hub.$emit('dimmerOff');
                        that.errors = {};
                        that.model = {};
                        that.models.push(res);
                    },
                    error: function(res) {
                        event_hub.$emit('update_error', res.responseJSON);
                        event_hub.$emit('dimmerOff');
                    }
                });
            }
        },
        computed: {
            searchStatus: function() {
                if (this.is_calculating) {
                    return '處理中...'
                } else {
                    return '✓ 完成';
                }
            },
            pageStart: function() {
                var that = this;
                return (that.currentPage - 1) * that.countOfPage;
            },
            totalPage: function() {
                var that = this;
                if(that.searchQuery.trim() === '') {
                    return Math.ceil(that.models.length / that.countOfPage);
                }
                else{
                    return Math.ceil(that.filteredModelCount / that.countOfPage);
                }
            },
            filteredModels: function() {
                var that = this;
                that.is_calculating = true;
                var result = that.models.filter(function (model) {
                    return String(model[that.selected_attribute]).indexOf(that.searchQuery) !== -1;
                });

                that.filteredModelCount = result.length;
                setTimeout(function () {
                    that.is_calculating = false;
                }, 500)
                return result.slice(
                    that.pageStart,
                    that.countOfPage + that.pageStart
                );
            }
        },
        watch: {
            searchQuery: function () {
                this.currentPage = 1;
                updateQueryStringParam('q', this.searchQuery);
                updateQueryStringParam('p', 1);
            }
        }
    })
}
